from random import randint, shuffle


N_Joueurs=4
N_Cartes=34
taille_X_terrain=5
taille_Y_terrain=5
cases_X_terrain=['A','B','C','D','E']
cases_Y_terrain=['1','2','3','4','5']


#-------------------------------------------------------------------------------------------------
#PARTIE FONCTIONS

#1
def affiche_plateau(L_joueurs):
    print('   | A B C D E |')
    print('---- - - - - - |')
    for i in range(5):
        L=['A','B','C','D','E']
        for k in range(len(L_joueurs)):
            if int(L_joueurs[k]['pos'][1])==i+1:          #Extraction des pions           
                nametag=L_joueurs[k]['pion']
                colonne=L_joueurs[k]['pos'][0]
                for n in range(5):                              
                    if colonne==L[n]:
                        L[n]=nametag                      #Met les pions a leur position
        for n in range(5):
            if (L[n] in ['X','O','Z','Y'])==False:
                L[n]='.'                                  #On rempli le reste avec des points
        ligne=' {} | {} {} {} {} {} |'.format(i+1,L[0],L[1],L[2],L[3],L[4])
        print(ligne)  
    print('----------------')

#-------------------

#2
def affiche_cartes(L_cartes):
    for carte in L_cartes :
        print(carte,end="")
        if carte!=L_cartes[-1]:#on écrit une virgule après chaque carte sauf pour la dernière
            print(", ",end="")
    print("")
    
#-----------------------     
            
#3
def valeur(carte):
    A = ['7','8','9','0', 'V', 'D', 'R', '1', 'J']  # valeurs autorisées pour le premier caractère de la chaîne symbolisant une carte

    parametre1 = carte[0]

    for i in range(len(A)):  # la liste A est dans l 'ordre de puissance donc on en profite !'
        if parametre1 == A[i]:  # on attribue la bonne valeur si tout est conforme / on ajoute 7 à i car A[i=0] a une valeur de 7 
            return i + 7

#----------------

#4
def KO(joueur):
    if int(joueur['pv']) > 0:
        return False
    else:
        return True
    
#-------------------

#5
def nb_KO(L_joueurs):
    compteur=0
    for i in range(len(L_joueurs)):
        if int(L_joueurs[i]['pv'])<=0:       #Pour chaque joueur on extrait le nombre de pv pour savoir si il est ko
            compteur=compteur+1
    return(compteur)

#----------------------

#6
def voisins(direction,case): 

    X=['A','B','C','D','E']
    Y=['1','2','3','4','5']

    A=[None,None]#on initialise des listes qui serviront plus tard
    B=[None,None]
    casesVoisines=[]

    #on affecte les 2 composantes du paramètre "case" à un indice correspondant à leur place dans les listes définissant le terrain
    x=X.index(case[0])
    y=Y.index(case[1])
    
# On affecte aux listes A et B une "abscisse gauche et une droite" de la case concernée pour la liste A et une "ordonnée supérieure et inférieure" pour la liste B si ces dernieres existent
    if x-1>=0:
        A[0]=x-1
    if x+1<=4:
        A[1]=x+1
    if y-1>=0:
        B[0]=y-1
    if y+1<=4:
        B[1]=y+1
# ainsi si par exemple, case="A3", on arrive à A=[None,1] et B=[1,3]

#désormais, il ne reste plus qu'à "convertir" ce tableau selon la direction souhaitée en cases voisines, que l'on va tour à tour ajouter dans la liste casesVoisines... 
    if direction=="diag":
        for i in A:
            if i!=None:
                for j in B:
                    if j!=None:
                        casesVoisines=casesVoisines+[X[i]+Y[j]]

    if direction=="orth":
        for i in A:
            if i!=None:
                casesVoisines=casesVoisines+[X[i]+case[1]]
        for j in B:
            if j!=None:
                casesVoisines=casesVoisines+[case[0]+Y[j]]

    return casesVoisines

#-------------------------------

#7
def est_voisin(j1,j2,direction):
    L=[4,'A','B','C','D','E',4]
    occ=L.index(j1['pos'][0])
    if direction=='orth':
        if (int(j2['pos'][1])==int(j1['pos'][1])+1 or int(j2['pos'][1])==int(j1['pos'][1])-1) and j1['pos'][0]==j2['pos'][0]:
            return(True)                     #On regarde si deux pions sur la même colonne sont sur des lignes adjacentes
        elif (j2['pos'][0]==L[occ-1] or j2['pos'][0]==L[occ+1]) and j1['pos'][1]==j2['pos'][1]:
            return(True)                     #On regarde si deux pions sur la même ligne sont sur des colonnes adjacentes
        else:
            return(False)
    elif direction=='diag':
        if (int(j2['pos'][1])==int(j1['pos'][1])+1 or int(j2['pos'][1])==int(j1['pos'][1])-1) and (j2['pos'][0]==L[occ-1] or j2['pos'][0]==L[occ+1]):
            return(True)                      #On regarde si des pions sur des lignes adjacentes sont sur des colonnes adjacentes et inversement
        else:
            return(False)

#------------------------------------

#8
def init_pioche():
    P = []  #liste symbolisant la Pioche
    A = [str(k) for k in range(7, 10)] + ['0', 'V', 'D', 'R', '1']
    B = ['P', 'T', 'C', 'K']

    for valeur in A:  # ce bloc va créer les 34 cartes constituant la pioche
        for symbole in B:
            P = P + [valeur + symbole]
    P = P + ['J1', 'J2']

    shuffle(P)#on mélange puis on retourne la liste obtenue

    return P

#-------------------------

#9
def init_defausse():#on retourne une liste vide 
    L = []
    return L

#-----------------------------

#10
def defausse2pioche(defausse,pioche):
    for i in range(0,len(defausse)):
        pioche.append(defausse[0])      #On ajoute la defausse a la pioche
        defausse.remove(defausse[0])    #On vide la defausse
    shuffle(pioche)                     #On mélange la pioche
    return None

#------------------------------

#11
def est_vide(paquet):# si le paquet est vide on retourne True, sinon on retourne False
    if paquet == []:
        return True
    else:
        return False
    
#--------------------------------    
   
#12
def pioche_cartes(n, L_cartes):
  cartes_piochees=[]
  i=0
  while len(L_cartes)>0 and i<n:# tant que il reste des cartes dans la pioche ( normalement il ne devrait pas arriver que n>len(L_cartes) au moment du lancement de la fonction (vérifications en amont dans le main)) et que on a pas déjà pioché n cartes
      cartes_piochees=[L_cartes.pop()]+cartes_piochees # on modifie L_cartes en place et on ajoute la carte piochée à la liste carte_piochées
      i=i+1
  return cartes_piochees

#------------------------------------

#13
def init_joueurs(n,pioche):
    import copy
    import random 
    L=['X','O','Y','Z'] #liste des pions disponnibles 
    C=['A1','E5','E1','A5'] #liste des positions 
    t=[k for k in range(7,15)] # création d'une liste représentant les différentes valeurs de cartes d'une des quatres familles 
    T=4*t+[15,15] #Création de la pioche qui servira pour définir qui commencera, les valeurs de 7 à 14 représentant les valeurs de 7 à As et les deux 15 sont les jokers
    random.shuffle(T)
    A=[1 for k in range(n)] #liste qui va servir à stocker les résulats des tirages dans T
    B=[k for k in range(n)] #liste qui va servir à stocker les différents joueurs dans l'ordre de passage défini à partir des règles du jeu
    J=[[k] for k in range(n)] #liste qui va servir à stocker les joueurs avant que l'on connaisse leur ordre de passage 
    joueur={'pion':'', 'pos':'', 'pv':10, 'cartes':[]} 
    for i in range(n):
        J[i]=copy.deepcopy(joueur)
        var=random.choice(L)
        L.remove(var)
        J[i]['pion']=var
        P=random.sample(pioche, 5)
        for k in range(len(P)):
            pioche.remove(P[k])
        J[i]['cartes']=P
        J[i]['pos']=C[i]
        while A.count(max(A))!=1:
           for j in range(n):
            var=random.choice(T)
            A[j]=var
        if n==2 :
            if A.index(max(A))==1:
                B[0]=J[1] 
                B[1]=J[0]
            else:
                B=J
        elif n==3:
           if A.index(max(A))==1:
               B[0]=J[1]
               B[1]=J[0]
               B[2]=J[2]
           elif A.index(max(A))==2:
               B[0]=J[2]
               B[1]=J[1]
               B[2]=J[0]
           else :
               B[0]=J[0]
               B[1]=J[2]
               B[2]=J[1]
        elif n==4:
            if A.index(max(A))==0:
                B[0]=J[0]
                B[1]=J[2]
                B[2]=J[1]
                B[3]=J[3]
            elif A.index(max(A))==1:
                B[0]=J[1]
                B[1]=J[3]
                B[2]=J[0]
                B[3]=J[2]
            elif A.index(max(A))==2:
                B[0]=J[2]
                B[1]=J[1]
                B[2]=J[3]
                B[3]=J[0]
            else:
                B[0]=J[3]
                B[1]=J[0]
                B[2]=J[2]
                B[3]=J[1]
    return(B)

#------------------------------------------------------
        
#14
def decisionAction(joueurActif,listeJoueurs): # fonction qui va déterminer si le joueur peut jouer une carte ou non et si oui quelle carte et si c'est une carte noire, un vecteur non nul qui lui donne le sens... elle retourne soit la carte et un vecteur , soit 'Tu joues R frr'

  # on établit diverses listes de cases voisines
  casesOrthVoisines=voisins('orth',joueurActif['pos'])
  casesDiagVoisines=voisins('diag',joueurActif['pos'])
  casesVoisines=casesOrthVoisines+casesDiagVoisines

  symbolesUsuels=['J','P','T','C','K']
  symbolesDisponibles=dict() # ce dictionnaire va indiquer quelles types de carte le joueur possède ainsi que leurs indices respectifs dans la main du joueur
  for carte in joueurActif['cartes']:
    iCarte=joueurActif['cartes'].index(carte)
    for parametreCarte in carte:
      if parametreCarte in symbolesUsuels:
        if parametreCarte not in symbolesDisponibles.keys():
          symbolesDisponibles[parametreCarte]=[iCarte]
        else:
          symbolesDisponibles[parametreCarte]=symbolesDisponibles[parametreCarte]+[iCarte]

  
  if 'J' in symbolesDisponibles.keys():# si le joueur possède un joker, il le joue en première priorité
    for i in [5,4,3,2,1]:
          for joueur in listeJoueurs:
              if joueur['pion']!=joueurActif['pion']:# pour filtrer le joueur actif
                  if joueur['pos'] in casesVoisines:
                      if len(joueur['cartes'])==i:
                          return joueurActif['cartes'][symbolesDisponibles['J'][0]],joueur['pos']

  if "C" in symbolesDisponibles.keys() or "K" in symbolesDisponibles.keys():# Si le joueur possède une carte rouge, il la joue en deuxième priorité
      if "C3" in casesVoisines:# si un joueur est à la place du king on l'attaque en premiere priorité
          symb='C'
          if 'C3' in casesOrthVoisines:
              symb='K'
          if symb in symbolesDisponibles.keys():# si on est en capacité d'attaquer la place du king
              for adversaire in listeJoueurs: #ce n'est pas grave que le joueur actif se trouve lui meme dans cette liste car il n'est nécessairement pas en "C3" (if précédent) donc il sera filtré au prochain if
                  if adversaire['pos']=='C3':
                      return joueurActif['cartes'][symbolesDisponibles[symb][0]],'C3'
      for i in [10,9,8,7,6,5,4,3,2,1]:# on attaque les joueurs avec le plus de PV en deuxieme priorité
          for adversaire in listeJoueurs:
              if adversaire['pion']!=joueurActif['pion']:#pour filtrer le joueur actif
                  if adversaire['pv']==i:# on repere un joueur ayant ce nombre de PV
                      if adversaire['pos'] in casesVoisines:# on regarde si il est à portée
                          symb='C'
                          if adversaire['pos'] in casesOrthVoisines:
                              symb='K'
                          if symb in symbolesDisponibles.keys():# si il est à portée, on regarde si on a la bonne carte pour l'attaquer
                              return joueurActif['cartes'][symbolesDisponibles[symb][0]],adversaire['pos'] # si toutes les conditions sont réunies, on l'attaque en donnant la carte et la direction
                    
  coupBas=False
  if coupBas==True:
      caseVisee="C3"#la possibilité de choix de coup bas par l'IA n'est pas encore aboutie mais on aime bien taper sur le mec occupant la place du king quand meme
      return "Tu fais un coup bas frr",caseVisee
  
  #si le joueur ne peut ni faire de doigt dans l'oeil (joker), ni d'attaque, ni de coup bas, il lui reste le déplacement, cependant ce déplacement doit toujours tendre à venir occuper la place du king le plus rapidement possible
  #Ce sont les instructions données par les codeurs à l'IA pour chaques cas...cette liste est de la forme A=[case0(='A1'),case1(='B1'),case2(='C1'),case3(='A2'),case4(='B2'),case5(='C2')] les déplacements possibles si le joueur actif occupe cette case, puis caseY=[priorité1,priorité2,...] les déplacements possibles à favoriser (se rapprochent plus efficacement du centre), puis prioritéZ=[deplacement1,deplacement2,...] tous les déplacements aussi efficaces dans ce niveau de priorité pour aller vers le centre.      Les int qui sont dans cette liste sont des indices de la liste significationDeplacement qui va interpreter ce déplacement en fonction de la position du rectangle de 6 cases auquel appartient la case du joueur actif
  A=[[[6],[1,2]],
  [[1,6],[2,7],[3]],
  [[1,6,7],[2,3]],
  [[2,6],[1,5],[0]],
  [[6],[1,2],[5,7,0,3],[4]],
  [[1],[2,3,6,7],[0,4,5]]]


  if joueurActif['pos']!='C3': # le joueur ne va pas se déplacer si il occupe déjà la place du King
    caseNumero=dict(A1=0,B1=1,C1=2,A2=3,B2=4,C2=5,E1=6,E2=7,E3=8,D1=9,D2=10,D3=11,E5=12,D5=13,C5=14,E4=15,D4=16,C4=17,A5=18,A4=19,A3=20,B5=21,B4=20,B3=23) #on assigne les cases du plateau à un numéro qui va visualiser les rectangles de 6 cases dont je parlais plus tôt 
    case=caseNumero[joueurActif['pos']]
    # on fait un "changement de base": par exemple une commande qui veut dire "aller vers le bas"([0,1]) dans le case 2 ("C1")(base 1) voudra dire "vers le haut"([0,-1]) dans la case 14 ("C5")(base 3) ou encore "vers la droite"([1,0]) dans la case 20 ("A3")(base 4)
    #( cette explication se fera dans la base1=(A1,axeLettres,axeChiffres) avec C2=[2,1] ) les couples de 0,1 et -1 suivants sont des vecteurs dans le plan du plateau de jeu avec l'axe des abscisses(l'axe des lettres) et l'axe des ordonnées(axe des chiffres) avec l'origine en 'A1' (exemples pour les cases: 'A2'=[1,0], C4=[2,3])(exemple pour les vecteurs : de (D2 à C3)=[-1,1], (de B4 à C4=[1,0])
    #exemple : base4=(A5,axeChiffres,axeLettres) avec B3=[2,1]
    # en fait signification déplacement est un peu comme une sorte de matrice de passage de la base canonique(base1) à la baseX (X=2,3 ou 4) ?
    if case>=0 and case<=5:#interpretation des déplacements dans la base 1  (si le joueur actif est dans le coin supérieur gauche)
      significationDeplacement=[[0,-1],[0,1],[1,0],[-1,0],[-1,-1],[1,-1],[1,1],[-1,1]] 
    if case>=6 and case<=11:#interpretation des déplacements dans la base 2 (coin supérieur droit)
      significationDeplacement=[[1,0],[-1,0],[0,1],[0,-1],[1,-1],[1,1],[-1,1],[-1,-1]]
    if case>=12 and case<=17: # interpretation des déplacements dans la base 3 (coin inférieur droit) 
      significationDeplacement=[[0,1],[0,-1],[-1,0],[1,0],[1,1],[-1,1],[-1,-1],[1,-1]]
    if case>=18 and case<=23:# interpretation des déplacements dans la base 4 (coin inférieur gauche)
      significationDeplacement=[[-1,0],[1,0],[0,-1],[0,1],[-1,1],[-1,-1],[1,-1],[1,1]]

    for priorite in A[case%6]: #si ce for n'atteint jamais le return, alors ça voudra dire que le joueur ne peut rien jouer soit parce qu'il n'a pas de cartes noires ou soit à cause d'autres joueurs qui auraient bloqué tous ses déplacements possibles du plus prioritaire au moins prioritaire jusqu'à ce que finalement, il n'ait plus de solutions de déplacement.  
      shuffle(priorite)# on fait en sorte qu'aucuns déplacements possible par rapport à un niveau de priorité ne soit favorisé par la théorie des grands nombres 
      for deplacement in priorite:# on regarde si ce déplacement(correctement interprété dans la base correspondante) est bloqué par un autre joueur
        vecteur=significationDeplacement[deplacement] # vecteur représentatif du déplacement (dans la base 1)
        caseVisee=caseAndVecteurToCase(joueurActif['pos'],vecteur)
        deplacementPossible=True
        for adversaire in listeJoueurs:
            if adversaire['pos']==caseVisee:
                deplacementPossible=False
        if deplacementPossible:# si personne ne bloque, on regarde si le joueur possède une carte noire correspondnate à ce déplacement
          symboleDeplacement='P'# on identifie la direction du déplacement
          for parametreDeplacement in vecteur:
            if parametreDeplacement==0:# un déplacement orthogonal aura toujours un 0 dans les composantes de son vecteur représentatif, contrairement à un déplacement diagonal qui n'a aucune composante nulle
              symboleDeplacement='T'
          if symboleDeplacement in symbolesDisponibles.keys():# si le joueur possède une carte pouvant produire ce déplacement
            return joueurActif['cartes'][symbolesDisponibles[symboleDeplacement][0]],caseVisee # on retourne la carte à jouer et l'instruction qui va avec (exemple: roi de trèfle, aller vers le bas)
  
  return "Tu joues R frr",[] #le joueur ne peut jouer aucune carte

#-------------------------------

#15
def parade(joueurVictime,carteAttaquante,traficCartes):
    pasDeParade=True# on part du principe que le joueur victime n' effectue pas de parade
    cartesPotentielles=[]
    for carte in joueurVictime['cartes']:
        if carte[1]==carteAttaquante[1] and valeur(carte)>valeur(carteAttaquante):#on stocke les cartes en mesure de déclencher une parade dans la liste cartesPotentielles
            cartesPotentielles=cartesPotentielles+[carte]
    if len(cartesPotentielles)>0:# si le joueur possède des cartes en mesure d'effectuer une parade, on joue la plus faible d'entre elles
        min=0
        for i in range(len(cartesPotentielles)):
            if valeur(cartesPotentielles[i])<valeur(cartesPotentielles[min]):
                min=i
        
        
        joueurVictime['cartes'].remove(cartesPotentielles[min])# le joueur 'joue' sa carte de parade
        traficCartes[1][1]=True
        traficCartes[1][2]=traficCartes[1][2]+[cartesPotentielles[min]]
        
        pasDeParade=False#la parade a été réalisée, le joueurVictime ne perd donc pas de PV
    return pasDeParade

#--------------------------------            

#16
def tomates(joueur_actif):
    joueur_actif['pv']=joueur_actif['pv']-1
    print("Tomates !\nLe joueur actif se repose un peu trop d'après le public qui le lui fait gentiment comprendre à grand renforts de fruits pourris et/ou autres ! Il en perd 1 PV...")
    return None

#------------------------

#17
def executionAction(joueurActif,decision,listeJoueurs,defausse):#joueurActif:dictionnaire;decision:(string,string);listeJoueurs:liste de dictionnaires;defausse:liste de string
    
    carte,caseCiblee=decision
    
    if carte!="Tu fais un coup bas frr":
      joueurActif['cartes'].remove(carte)# le joueur actif 'joue' sa carte
      defausse.append(carte)#on la place dans la défausse
    
    if decision[0][0]=="J":#si le joueur actif a joué un joker, on effectue un doigt dans l'oeil à un joueur choisit de façon adéquate
        for adversaire in listeJoueurs:
            if adversaire['pos']==caseCiblee:# on trouve l'adversaire correspondnat à la case ciblée choisie de façon adéquate dans decisionActions
                cartePiochee=pioche_cartes(1,adversaire['cartes']) #on lui pioche la carte du dessus de sa main
                joueurActif['cartes']=joueurActif['cartes']+cartePiochee #on ajoute cette carte sur le dessus de la main du joueur actif
    
    if decision[0][1] in ["C","K"]:# le joueur actif a joué une carte rouge, c'est une attaque ou une poussée
        pousseePossible=False    
        if caseCiblee=="C3":
            vecteurImpact=twoCasesToVecteur(joueurActif['pos'],"C3")
            caseAterrissage=caseAndVecteurToCase("C3",vecteurImpact)
            pousseePossible=True
            for joueur in listeJoueurs:
                if joueur['pos']==caseAterrissage:
                    pousseePossible=False
            if pousseePossible:
                for joueur in listeJoueurs:
                    if joueur['pos']=="C3":
                        joueur['pos']=caseAterrissage
                        
        if pousseePossible==False:
            for adversaire in listeJoueurs:
                if adversaire['pos']==caseCiblee:
                    pasDeParade=parade(adversaire,carte,defausse)#la fonction parade() va regarder si le joueur victime peut effectuer une carte, si oui elle "joue" la plus faible carte convenant, la place dans la défausse et return False, si non elle ne fait rien et retourne True
                    if pasDeParade:
                        adversaire['pv']=adversaire['pv']-1# si il n'y a pas de parade, le coup retire 1 PV au joueur Victime
                        if joueurActif['pos']=="C3":
                            adversaire['pv']=adversaire['pv']-1#si le joueur actif occupe la place du King, le joueur victime perd 1 PV supplémentaire
            
    if decision[0][1] in ["T","P"]:# le joueur actif a joué une carte noire, c'est un déplacement
        for joueur in listeJoueurs:
            if joueur==joueurActif:
                joueur['pos']=caseCiblee
    
    if decision[0]=="Tu fais un coup bas frr":#le joueur actif décide d'effectuer un coup bas 
        #decisionActions va décider de façon adéquate (intérêt stratégique, le joueur visé possède 2 cartes ou plus, le joueur actif en possede 3 ou plus,etc...) le joueur qui subira le coup bas. caseCiblee est donc la case accueillant ce joueur
        for adversaire in listeJoueurs:
            if adversaire['pos']==caseCiblee:
                for a in range(2):# on place les deux cartes de plus haute valeur du joueur visé dans la défausse
                  max=0
                  for i in range(len(adversaire['cartes'])):
                    if valeur(adversaire['cartes'][i])>valeur(adversaire['cartes'][max]):
                      max=i
                  defausse=defausse+[adversaire['cartes'].pop(max)]
                for a in range(3):# on place les trois cartes de plus faible valeur du joueur actif dans la défausse
                  min=0
                  for i in range(len(joueurActif['cartes'])):
                    if valeur(joueurActif['cartes'][i])<valeur(joueurActif['cartes'][min]):
                      min=i
                  defausse=defausse+[joueurActif['cartes'].pop(min)]

#------------------------

#18
X=['A','B','C','D','E']
Y=['1','2','3','4','5']
def twoCasesToVecteur(case1,case2):
    coord_case1=[X.index(case1[0]),Y.index(case1[1])]
    coord_case2=[X.index(case2[0]),Y.index(case2[1])]
    vecteur=[coord_case2[0]-coord_case1[0],coord_case2[1]-coord_case1[1]]
    return vecteur
def caseAndVecteurToCase(caseDepart,vecteur):
    coord_caseDepart=[X.index(caseDepart[0]),Y.index(caseDepart[1])]
    coord_caseArrivee=[coord_caseDepart[0]+vecteur[0],coord_caseDepart[1]+vecteur[1]]
    caseArrivee=X[coord_caseArrivee[0]]+Y[coord_caseArrivee[1]]
    return caseArrivee


#-------------------------------------------------------------------------------------------------------
#PARTIE TESTS
        
#Liste des 13 fonctions :
     #1   #affiche_plateau(L_joueurs)          
     #2   #affiche_cartes(L_cartes)            
     #3   #valeur(carte)                       
     #4   #KO(joueur)                          
     #5   #nb_KO(L_joueurs)                    
     #6   #voisins(direction,case)             
     #7   #est_voisin(j1,j2,direction)         
     #8   #init_pioche()                       
     #9   #init_defausse()                     
    #10   #defausse2pioche(defausse,pioche)    
    #11   #est_vide(paquet)                    
    #12   #pioche_cartes(n,L_cartes)           
    #13   #init_joueurs(n,pioche)              
    #14   #decisionActions(joueurActif,listeJoueurs) 
    #15   #parade(joueurVictime,carteAttaquante,defausse)
    #16   #tomates(joueur_actif)
    #17   #executionAction(joueurActif,decision,listeJoueurs,traficCartes)
    #18   #twoCasesToVecteur(case1,case2)
          #caseAndVecteurToCase(caseDepart,vecteur)
                              
            

if __name__ == '__main__':

    print("\nTest de Fonction 1 : affiche_plateau(L_joueurs)")
    print('Test 1 -> j1(X) en A1, j2(O) en E1, j3(Y) en C1')
    L_joueurs1 = [{'pion': 'X','pos': 'A1','pv': 6,'cartes': []},
                  {'pion': 'O','pos': 'E1','pv': 6,'cartes': []},
                  {'pion': 'Y','pos': 'C1','pv': 6,'cartes': []}]
    affiche_plateau(L_joueurs1)

    print('Test 2 -> j1(X) en C1, j2(O) en C3, j3(Y) en C5, j4(Z) en C2')
    L_joueurs2 = [{'pion': 'X','pos': 'C1','pv': 6,'cartes': []},
                  {'pion': 'O','pos': 'C3','pv': 6,'cartes': []},
                  {'pion': 'Y','pos': 'C5','pv': 6,'cartes': []},
                  {'pion': 'Z','pos': 'C2','pv': 6,'cartes': []}]
    affiche_plateau(L_joueurs2)

    print('Test 3 -> j1(X) en A2, j2(O) en D5')
    L_joueurs3 = [{'pion': 'X','pos': 'A2','pv': 6,'cartes': []},
                  {'pion': 'O','pos': 'D5','pv': 6,'cartes': []}]
    affiche_plateau(L_joueurs3)
    print('Ce sont bien les affichages attendus')
    
    

    print("\nTest de Fonction 2 : affiche_cartes(L_cartes)")
    L_cartes=['8C', 'RC', 'VK', '1T', 'J2']
    print("On teste la fonction avec L_cartes={} on attend un affichage tel que : '8C, RC, VK, 1T, J2'".format(L_cartes))
    print("Résultat --> la fonction affiche :",end="")
    affiche_cartes(L_cartes)
    print("\nC'est bien l'affichage attendu") 



    print("\nTest de Fonction 3 : valeur(carte)")
    cartes=['1P','0T','8K','J2','9C','VK']
    valeursAttendues=[14,10,8,15,9,11]
    print("On teste avec les cartes ",end="")
    for carte in cartes:
        print(carte,", ",end="")
    print("\nLes résultats attendus sont ",end="")
    for valeurAttendue in valeursAttendues:
        print(valeurAttendue,", ",end="")
    print("\nRésultats : ",end="")
    for carte in cartes:
        print(valeur(carte),", ",end="")
    print("")
    
    

    print("\nTest de Fonction 4 : KO(joueur)")
    joueurs=[]
    for N_pv in [6,0,100,-20]: 
        joueurs=joueurs+[dict(pion='X',pos='A1',pv=N_pv,cartes=['8C', 'RC', 'VK', '1T', 'J2'])] # listes de dictionnaires des joueurs 1 à 4 avec les PV qui changent
    print("On a : joueurs 1 à 4 respectivement de PV 6,0,100,-20")
    print("Les résultats attendus de la fonction KO(joueur) sur les joueurs 1 à 4 sont respectivement False,True,False et True")
    print("La fonction retourne respectivement {},{},{} et {}".format(KO(joueurs[1-1]),KO(joueurs[2-1]),KO(joueurs[3-1]),KO(joueurs[4-1])))
    
    

    print("\nTest de Fonction 5 : nb_KO(L_joueurs)")
    print('Test 1 -> attendu: 2 KO')
    L_joueurs1 = [{'pion': 'X','pos': 'A1','pv': 6,'cartes': []},
                  {'pion': 'O','pos': 'E1','pv': -6,'cartes': []},
                  {'pion': 'Y','pos': 'C1','pv': 0,'cartes': []}]
    print('résultat: ', nb_KO(L_joueurs1))

    print('Test 2 -> attendu: 4 KO')
    L_joueurs2 = [{'pion': 'X','pos': 'A1','pv': -3,'cartes': []},
                  {'pion': 'O','pos': 'E1','pv': -6,'cartes': []},
                  {'pion': 'Y','pos': 'C1','pv': 0,'cartes': []},
                  {'pion': 'Z','pos': 'C2','pv': -6,'cartes': []}]
    print('résultat: ', nb_KO(L_joueurs2))

    print('Test 3 -> attendu: 0 KO')
    L_joueurs3 = [{'pion': 'X','pos': 'A1','pv': 6,'cartes': []},
                  {'pion': 'O','pos': 'E1','pv': 6,'cartes': []}]
    print('résultat: ', nb_KO(L_joueurs3))
    
    

    print("\nTest de Fonction 6 : voisins(direction,case)")
    print ('avec la direction orthogonale et le pion en case A1 , attendu : [ B1, A2 ]')
    print("Résultat : ",voisins("orth","A1"))
    print ('avec la direction orthogonale et le pion en case B5 , attendu : [A5, C5, B4]')
    print("Résultat : ",voisins("orth","B5"))
    print ('avec la direction orthogonale et le pion en case C3 , attendu : [B3, D3, C2, C4]')
    print("Résultat : ",voisins("orth","C3"))
    print ('avec la direction diagonale et le pion en case E1 , attendu : [D2]')
    print("Résultat : ",voisins("diag","E1"))
    print ('avec la direction diagonale et le pion en case D5 , attendu : [C4, E4]')
    print("Résultat : ",voisins("diag","D5"))
    print ('avec la direction diagonale et le pion en case B2 , attendu : [A1, A3, C1, C3]')
    print("Résultat : ",voisins("diag","B2"))
    


    print("\nTest de Fonction 7 : est_voisin(j1,j2,direction)")
    coupleJoueurs=[]
    for position in ['B2','C2','D2','D3','D4','C4','B4','B3']:#8 couples j1,j2 différents pour effectuer 8 tests différents
        coupleJoueurs=coupleJoueurs+[[dict(pion='X',pos=position,pv=6,cartes=[]),dict(pion='X',pos='C3',pv=6,cartes=[])]]
    print("pour la direction orthogonale")
    print("Les résultats attendus sont respectivement False,True,False et True")
    for i in range(0,3+1):
        print("Test ",i+1," : j1 en ",coupleJoueurs[i][0]['pos']," et j2 en C3")
        print("Résultat : ",est_voisin(coupleJoueurs[i][0],coupleJoueurs[i][1],'orth'))
    print("pour la direction diagonale")
    print("Les résultats attendus sont respectivement True,False,True et False")
    for i in range(4,7+1):
        print("Test ",i+1," : j1 en ",coupleJoueurs[i][0]['pos']," et j2 en C3")
        print("Résultat : ",est_voisin(coupleJoueurs[i][0],coupleJoueurs[i][1],'diag'))
    
    

    print("\nTest de Fonction 8 : init_pioche()")
    A=init_pioche()
    B=init_pioche()
    print("on vérifie si le fonction crée bien des tas de 34 cartes, mélangées différemment à chaque fois")
    print("On crée donc deux nouvelles pioches A et B avec init_pioche()")
    print("Ainsi, A : ")
    print(A)
    print("Et B : ")
    print(B)
    print("On voit bien que A et B ont les mêmes cartes mais sont mélangées différemment")
    print("Les Résultats attendus de len(A) et len(B) sont 34")
    print("Résultats : len(A)=",len(A)," et len(B)=",len(B))
    print("Ainsi, les pioches A et B sont bien constituées de 34 cartes")
    
    

    print("\nTest de Fonction 9 : init_defausse()")
    print('Le résultat attendu de la fonction init_defausse() est une liste vide et notre fonction retourne : ',init_defausse())
    print("OK")
    
    

    print("\nTest de Fonction 10 : defausse2pioche(defausse,pioche)")
    A=[1,2,4,5,2,1]
    B=[2,4,7,8]
    print('On prend A = ',A,'comme défausse et B = ',B,'comme pioche et on execute la fonction')
    defausse2pioche(A,B)
    print('A est maintenant ',A,' (défausse vidée) et B est maintenant', B,' (pioche et défausse mélangées ensemble)')
    print("OK")
    
    

    print("\nTest de Fonction 11 : est_vide(paquet)")
    print ('avec la liste L=[] , attendu : True')
    print("Résultat : ",est_vide([]))
    print ('avec la liste L= [8C, RC, VK, 1T, 2T] , attendu : False')
    print("Résultat : ",est_vide(['8C', 'RC', 'VK', '1T', '2T']))
    
    

    print("\nTest de Fonction 12 : pioche_cartes(n,L_cartes)")
    print("Avec n=3 et L_cartes=['VP', '9K','1K', 'RT', '8T'], Résultat attendu : ['1K', 'RT', '8T'],['VP', '9K']")
    print("Résultat : ",pioche_cartes(3,['VP', '9K','1K', 'RT', '8T']))
    print("Avec n=6 et L_cartes=['VP', '9K','1K', 'RT', '8T'], Résultat attendu : ['VP', '9K','1K', 'RT', '8T'],[]")
    print("Résultat : ",pioche_cartes(6,['VP', '9K','1K', 'RT', '8T']))
    print("Avec n=-2 et L_cartes=['VP', '9K','1K', 'RT', '8T'], Résultat attendu : 'error',['VP', '9K','1K', 'RT', '8T']")
    print("Résultat : ",pioche_cartes(-2,['VP', '9K','1K', 'RT', '8T']))
    print("Avec n=3 et L_cartes=[], Résultat attendu : 'error',[]")
    print("Résultat : ",pioche_cartes(3,[]))
    
    

    print("\nTest de Fonction 13 : init_joueurs(n,pioche)")

    P=['1C','7C','8C','9C','0C','VC','DC','RC','1P','7P','8P','9P','0P','VP','DP','RP','1K','7K','8K','9K','0K','VK','DK','RK','1T','7T','8T','9T','0T','VT','DT','RT']

    print('Tests pour 2 joueurs :\n')
    for i in range(3):
        import copy
        p=copy.deepcopy(P)
        O=init_joueurs(2,p)
        J1=O[0]
        J2=O[1]
        a='OK'
        if J1['pos']==J2['pos']:
            a='NOK'
        elif J1['pion']==J2['pion']:
            a='NOK'
        for k in range(5):
            if J1['cartes'][k] in J2['cartes']:
                a='NOK'
        print("La fonction init_joueurs pour {} joueurs donne : \n {} \n Le test de cette fonction nous dit qu'elle est {} \n ".format(2,O,a))
    
    print('Tests pour 3 joueurs :\n')
    for i in range(3):
        p=copy.deepcopy(P)
        a='OK'
        O=init_joueurs(3,p)
        J1=O[0]
        J2=O[1]
        J3=O[2]
        CARTES=J1['cartes']+J2['cartes']+J3['cartes']
        PIONS=[J1['pion'],J2['pion'],J3['pion']]
        POS=[J1['pos'],J2['pos'],J3['pos']]
        if POS[0]=='A1' and POS[2]!='E5':
            a='NOK'
        elif POS[0]=='E1' and POS[2]!='A1': #C'est suffisant pour savoir que toutes les positions sont bonnes avec le comptage qui sera effectué plus tard 
            a='NOK'
        elif POS[0]=='E5' and POS[2]!='E1':
            a='NOK'
        for k in range(3):
            if POS.count(POS[k])!=1:
                a='NOK'
            elif PIONS.count(PIONS[k])!=1:
                a='NOK'
        for j in range(len(CARTES)):
            if CARTES.count(CARTES[j])!=1:
                a='NOK'
        print("La fonction init_joueurs pour {} joueurs donne : \n {} \n Le test de cette fonction nous dit qu'elle est {} \n ".format(3,O,a))
        
    
    print('Tests pour 4 joueurs :\n')
    for i in range(3):
        p=copy.deepcopy(P)
        a='OK'
        O=init_joueurs(4,p)
        J1=O[0]
        J2=O[1]
        J3=O[2]
        J4=O[3]
        CARTES=J1['cartes']+J2['cartes']+J3['cartes']+J4['cartes']
        PIONS=[J1['pion'],J2['pion'],J3['pion'],J4['pion']]
        POS=[J1['pos'],J2['pos'],J3['pos'],J4['pos']]
        if POS[0]=='A1' and POS[3]!='A5':  # C'est suffisant pour savoir que toutes les positions sont bonnes avec le comptage qui sera effectué plus tard 
            if POS[1]!='E1':
                a='NOK'
        elif POS[0]=='E1' and POS[3]!='A1':
            if POS[1]!='E5':
                a='NOK'
        elif POS[0]=='E5' and POS[3]!='E1':
            if POS[1]!='A5':
                a='NOK'
        elif POS[0]=='A5' and POS[3]!='E5':
            if POS[1]!='A1':
                a='NOK'
        for k in range(4):
            if POS.count(POS[k])!=1:
                a='NOK'
            elif PIONS.count(PIONS[k])!=1:
                a='NOK'
        for j in range(len(CARTES)):
            if CARTES.count(CARTES[j])!=1:
                a='NOK'
        print("La fonction init_joueurs pour {} joueurs donne : \n {} \n Le test de cette fonction nous dit qu'elle est {} \n ".format(4,O,a))
      
        
        print("\nTest de Fonction 14 : décisions actions")
        print("fonction qui va déterminer si le joueur peut jouer une carte ou non et si oui quelle carte et si c'est une carte noire, un vecteur non nul qui lui donne le sens... elle retourne soit la carte et un vecteur , soit 'Tu joues R frr'")
        L_Joueurs=[{'pion': 'Y', 'pos': 'B5', 'pv': 7, 'cartes': ['8K', '9K', '1K','5T']},{'pion': 'Z', 'pos': 'C2', 'pv': 10, 'cartes': ['VC', '7K', 'RC']},{'pion': 'X', 'pos': 'C3', 'pv': 7, 'cartes': ['0P', '1P', '8T', '7P', '9C']},{'pion': 'O','pos': 'C4','pv': 10,'cartes': ['0K', 'RK', 'DK', '9T', 'J1']}]
        affiche_plateau(L_Joueurs)
        print(decisionAction(L_Joueurs[0],L_Joueurs))
        print('En effet le joueur Y ne peut pas attaquer en diagonal il se raproche donc de la case C3 avec sa seul carte de déplacement')
        print(decisionAction(L_Joueurs[1],L_Joueurs))
        print('Le joueur Z va en attaquer la personne en C3 c\'est le seul qu\il peut attaquer')
        print(decisionAction(L_Joueurs[3],L_Joueurs))
        print('Le joueur O va attaquer le joueur en C3 en priorité sur le joueur en B5 et avec un joker en priorité il fait un doigt dans l\'oeil')
        print(decisionAction(L_Joueurs[2],L_Joueurs))
        print('Le joueur X reste sur sa case car il est en C3 et n\'a pas de cartes pour attaquer en ligne il ne peut donc pas attaquer Z ou O')

